package org.mmga.clubs.service;

import org.mmga.clubs.dao.PermissionDao;
import org.mmga.clubs.dao.PermissionRouterDao;
import org.mmga.clubs.entities.permission.Permission;
import org.mmga.clubs.entities.permission.PermissionVo;
import org.mmga.clubs.entities.router.Router;
import org.mmga.clubs.entities.router.RouterVo;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class PermissionService {
    private final PermissionDao permissionDao;
    private final PermissionRouterDao permissionRouterDao;
    private final RouterService routerService;
    public PermissionService(PermissionDao permissionDao, PermissionRouterDao permissionRouterDao, RouterService routerService) {
        this.permissionDao = permissionDao;
        this.permissionRouterDao = permissionRouterDao;
        this.routerService = routerService;
    }
    public Permission packagePermission(PermissionVo vo){
        int id = vo.id();
        List<RouterVo> routerVos = permissionRouterDao.getRouterByPermissionId(id);
        List<Router> routers = this.routerService.packageRouter(routerVos);
        return new Permission(id, vo.name(), routers);
    }
}
